﻿// Copyright 2004-2010 Castle Project - http://www.castleproject.org/
// 
// Licensed under the Apache License, Version 2.0 (the "License");
// you may not use this file except in compliance with the License.
// You may obtain a copy of the License at
// 
//     http://www.apache.org/licenses/LICENSE-2.0
// 
// Unless required by applicable law or agreed to in writing, software
// distributed under the License is distributed on an "AS IS" BASIS,
// WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
// See the License for the specific language governing permissions and
// limitations under the License.

namespace Castle.MicroKernel.Proxy
{
	/// <summary>
	/// Represents a reference to an existing object.
	/// </summary>
	/// <typeparam name="T"></typeparam>
	public class InstanceReference<T> : IReference<T>
	{
		private readonly T instance;

		public InstanceReference(T instance)
		{
			this.instance = instance;
		}

		public T Resolve(IKernel kernel, CreationContext context)
		{
			return instance;
		}
	}
}