// Copyright 2004-2009 Castle Project - http://www.castleproject.org/
// 
// Licensed under the Apache License, Version 2.0 (the "License");
// you may not use this file except in compliance with the License.
// You may obtain a copy of the License at
// 
//     http://www.apache.org/licenses/LICENSE-2.0
// 
// Unless required by applicable law or agreed to in writing, software
// distributed under the License is distributed on an "AS IS" BASIS,
// WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
// See the License for the specific language governing permissions and
// limitations under the License.

namespace Castle.Windsor.Tests.Components
{
	using System;
	using Castle.Core;
	using Castle.Core.Interceptor;

	internal interface IInternal
	{
		void Do();
	}

	[Interceptor(typeof(StandardInterceptor))]
	public class CalculatorServiceWithInternalInterface : ICalcService, IInternal
	{
		#region ICalcService Members

		public int Sum(int x, int y)
		{
			throw new NotImplementedException();
		}

		public bool Initialized
		{
			get { throw new NotImplementedException(); }
		}

		public bool Disposed
		{
			get { throw new NotImplementedException(); }
		}

		#endregion

		#region IInternal Members

		public void Do()
		{
			throw new NotImplementedException();
		}

		#endregion
	}
}
