﻿using System;
using System.Net;
using System.Windows;
using System.Windows.Controls;
using System.Windows.Documents;
using System.Windows.Ink;
using System.Windows.Input;
using System.Windows.Media;
using System.Windows.Media.Animation;
using System.Windows.Shapes;
using Castle.Core.Resource;
using Castle.MicroKernel.Registration;
using Castle.Windsor;
using Castle.Windsor.Configuration.Interpreters;
using Microsoft.Silverlight.Testing;
using Microsoft.VisualStudio.TestTools.UnitTesting;
using SilverlightTest.Domain;
using Child = SilverlightTest.Domain.Child;

namespace SilverlightTest
{
	[TestClass]
	public class Tests
	{
		

		

		private string config = "<configuration><components>" +
										"<component id=\"child\" " +
													  "service=\"SilverlightTest.Domain.IChild, SilverlightTest, Version=1.0.0.0, Culture=neutral, PublicKeyToken=null\" " +
													  "type=\"SilverlightTest.Domain.Child, SilverlightTest, Version=1.0.0.0, Culture=neutral, PublicKeyToken=null\" />" +
										"<component id=\"parent\" " +
													  "service=\"SilverlightTest.Domain.IParent, SilverlightTest, Version=1.0.0.0, Culture=neutral, PublicKeyToken=null\" " +
													  "type=\"SilverlightTest.Domain.Parent, SilverlightTest, Version=1.0.0.0, Culture=neutral, PublicKeyToken=null\" />" +
										"</components></configuration>";

		[TestMethod]
		public void ComponentRegistrationFluent()
		{
			WindsorContainer container = new WindsorContainer();
			container.Register(Component.For<IChild>().ImplementedBy<Child>().LifeStyle.Transient)
			 .Register(Component.For<IParent>().ImplementedBy<Parent>().LifeStyle.Transient);
			// resolve the object
			IParent p = container.Resolve<IParent>();
			Assert.IsNotNull(p);
			Assert.IsInstanceOfType(p, typeof(Parent));
			Assert.IsNotNull(p.ChildConstructorDependency);
			Assert.IsInstanceOfType(p.ChildConstructorDependency, typeof(Child));
			Assert.IsNotNull(p.ChildProperty);
			Assert.IsInstanceOfType(p.ChildProperty, typeof(Child));
		}

		[TestMethod]
		public void ComponentRegistrationString()
		{
			WindsorContainer container = new WindsorContainer(new XmlInterpreter(new StaticContentResource(config)));
			// resolve the object
			IParent p = container.Resolve<IParent>();
			Assert.IsNotNull(p);
			Assert.IsInstanceOfType(p, typeof(Parent));
			Assert.IsNotNull(p.ChildConstructorDependency);
			Assert.IsInstanceOfType(p.ChildConstructorDependency, typeof(Child));
			Assert.IsNotNull(p.ChildProperty);
			Assert.IsInstanceOfType(p.ChildProperty, typeof(Child));
		}
	}
}